/*	Blunder Delay
	A Thunderbird Extension to automatically flush the Unsent Messages folder
	at regular intervals.

	By Andrew C. Brown
	http://bananabread.net

	ChangeLog:

	0.3.1	Change variables c, timer and observe to avoid namespace conflicts
	0.3.0	Add localization file
	0.2.0	Preferences functional
	0.1.0	First released code.
		Shortcoming: Only operates when main window is visible.
		Preferences aren't yet functional.
*/

var BlunderDelay_observer = {
  // Components.interfaces.nsIObserver
  observe: function(aSubject, aTopic, aData)
  {
	goDoCommand('cmd_sendUnsentMsgs')
  },

  QueryInterface : function(iid)
  {
	if ( iid.equals(Components.interfaces.nsIObserver) || 
		iid.equals(Components.interfaces.nsISupportsWeakReference) ||
		iid.equals(Components.interfaces.nsISupports)
	)
	return this;
	throw Components.results.NS_NOINTERFACE;
  }
};

var BlunderDelay_c, BlunderDelay_timer;
function initSendTimer()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefBranch);

	if (prefs.prefHasUserValue("extensions.blunderdelay.enable"))
		var enabled = prefs.getBoolPref("extensions.blunderdelay.enable");
	else var enabled = "true";

	if (enabled)
	{
		if (prefs.prefHasUserValue("extensions.blunderdelay.interval"))
			var minutes = prefs.getIntPref("extensions.blunderdelay.interval");
		else
			var minutes = 10;

		BlunderDelay_c = Components.classes["@mozilla.org/timer;1"];
		BlunderDelay_timer = BlunderDelay_c.createInstance(Components.interfaces.nsITimer);

		var milliseconds = Math.max(1000,Math.round(minutes * 60 * 1000));

		BlunderDelay_timer.init(BlunderDelay_observer,  milliseconds, BlunderDelay_timer.TYPE_REPEATING_SLACK);
	}

	OnLoadMessenger(); // Making up for overriding it in the messenger.xul
}
